2014년 6월 3일 화요일

CentOS 5에서 GCC 4.8 사용하기

개발을 하다보면 새로운 기능을 쓰고 싶고, 새로운 기능을 쓰려면 새로운 개발툴을 깔아야 하는 상황을 종종 맞이한다.

보통은 Source RPM 대충 찾아서 깔짝깔짝 하면 뿅하고 새 패키지를 사용할 수 있다지만, GCC 같은 건 glibc, glibc++ 같은 기본 라이브러리와도 매우 밀접한 연관을 갖으며, 설치할 때도 다른 이름으로 지정해주지 않으면, 이미 설치한 무수히 많은 프로그램과 충돌이 나기 쉽다. 애초에 컴파일도 쉽지 않다.

OS 업그래이드를 이야기해도 막상 서버 관리자 입장에선 매우 난처할 수 있고...

그러던 참에 CentOS5나 6(혹은 그것에 대응하는 RHEL)에서 GCC 4.8 버전을 쉽게 사용할 수 있는 방법을 찾았다.

devtoolset 프로젝트가 바로 그것인데, 딱히 홈페이지도 없다.
참조: http://people.centos.org/tru/devtools-2/

설치 방법은 간단하다. readme.txt에 있는 것과 같이 하면 된다. ㅋㅋㅋ

root권한으로...

# YUM 저장소 설정
wget http://people.centos.org/tru/devtools-2/devtools-2.repo -O /etc/yum.repos.d/devtools-2.repo

# GCC 설치
yum install devtoolset-2-gcc devtoolset-2-binutils

츠암 쉽죠잉?

근데 이거만 한다고 4.1(CentOS5기준)이 4.8로 바뀌는 것은 아니다.

source /opt/rh/devtoolset-2/enable

위 명령으로 GCC 툴체인을 변경할 수 있다.

매번하기 귀찮으면 ~/.bashrc 파일에 위 내용을 넣어서 해결할 수 있다.